;; printstr.inc
;;
;; (C) 2001, Particle Corp.


; provides some basic character/string printing to console

%ifndef PRINTSTR_INC
%define PRINTSTR_INC

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; print a character (OS independent)...
;; input: AX = char
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
printchar:
        push    ax
        push    bx
        mov     ah,0x0E         ; print a char & advance position
        mov     bx,0x0007       ; set page = 0, and attribute = 7
        int     0x10            ; call BIOS
        pop     bx
        pop     ax
        ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; print string (null terminated)
;; input: BX = pointer to beg of string
;; (note: this method is kind of weird, it's kind of recursive,
;;      yet, it's not recursive... hmm...)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
printstr:
        mov     al,[bx]                 ; get string char
        cmp     al,0                    ; is it 0?
        je      printstr.done        ; if yes, we're done
        call    printchar               ; else, print that char
        inc     bx                      ; increment pointer
        jmp     printstr             ; repeat
.done   ret                             ; return

%endif
